//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  6
#property indicator_color1   DimGray
#property indicator_color2   DeepSkyBlue
#property indicator_color3   DeepSkyBlue
#property indicator_color4   PaleVioletRed
#property indicator_color5   PaleVioletRed
#property indicator_color6   DimGray
#property indicator_style6   STYLE_DOT
#property indicator_width2   3
#property indicator_width3   3
#property indicator_width4   3
#property indicator_width5   3
#property indicator_minimum -100
#property indicator_maximum  100

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    DpoPeriod       = 14;
extern int    AveragePeriod   =  3;
extern int    Price           = PRICE_CLOSE;
extern double LevelUp         =  80;
extern double LevelDn         = -80;
extern bool   UseInverseFisherTransform = true;
extern double TransformMultiplier = 500;
extern bool   Interpolate     = true;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double prices[];
double dpo[];
double dpoUa[];
double dpoUb[];
double dpoDa[];
double dpoDb[];
double avg[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);          
   SetIndexBuffer(0, dpo);
   SetIndexBuffer(1, dpoUa);
   SetIndexBuffer(2, dpoUb);
   SetIndexBuffer(3, dpoDa);
   SetIndexBuffer(4, dpoDb);
   SetIndexBuffer(5, avg);
   SetIndexBuffer(6, prices);
   SetIndexBuffer(7, trend);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);

         SetLevelValue(0,LevelUp); 
         SetLevelValue(1,LevelDn);          
         
      //
      //
      //
      //
      //
          
   IndicatorShortName(timeFrameToString(timeFrame)+" IFT of DPo (" + DpoPeriod + ")");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int    counted_bars = IndicatorCounted();
   int    i,k,n,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { dpo[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   int shift = DpoPeriod/2+1;
   if (calculateValue || timeFrame == Period())
   {
      if (!calculateValue && trend[limit]== 1) CleanPoint(limit,dpoUa,dpoUb);
      if (!calculateValue && trend[limit]==-1) CleanPoint(limit,dpoDa,dpoDb);
      for(i = limit; i >= 0; i--)
      {
         prices[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         dpoUa[i] = EMPTY_VALUE;
         dpoUb[i] = EMPTY_VALUE;
         dpoDa[i] = EMPTY_VALUE;
         dpoDb[i] = EMPTY_VALUE;
         double tdpo = TransformMultiplier*(prices[i]-iMA(NULL,0,DpoPeriod,0,MODE_SMA,Price,i+shift));
            if (UseInverseFisherTransform)
                  dpo[i] = 100.0*(MathExp(2.0*tdpo)-1.0)/(MathExp(2.0*tdpo)+1.0);
            else  dpo[i] = 100.0*tdpo/TransformMultiplier;
         avg[i]    = 0; for (k=0; k<AveragePeriod; k++) avg[i] += dpo[i+k]; avg[i] /= AveragePeriod;
         trend[i]  = trend[i+1];
                  if (dpo[i]>LevelUp)                    trend[i]= 1;
                  if (dpo[i]<LevelDn)                    trend[i]=-1;
                  if (dpo[i]<LevelUp && dpo[i]>LevelDn) trend[i]= 0;
                  if (!calculateValue && trend[i] ==  1) PlotPoint(i,dpoUa,dpoUb,dpo);
                  if (!calculateValue && trend[i] == -1) PlotPoint(i,dpoDa,dpoDb,dpo);
      }      
      manageAlerts();
      return(0);
   }      
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         dpo[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",DpoPeriod,AveragePeriod,Price,LevelUp,LevelDn,UseInverseFisherTransform,TransformMultiplier,0,y);
         avg[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",DpoPeriod,AveragePeriod,Price,LevelUp,LevelDn,UseInverseFisherTransform,TransformMultiplier,5,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",DpoPeriod,AveragePeriod,Price,LevelUp,LevelDn,UseInverseFisherTransform,TransformMultiplier,7,y);
         dpoUa[i] = EMPTY_VALUE;
         dpoUb[i] = EMPTY_VALUE;
         dpoDa[i] = EMPTY_VALUE;
         dpoDb[i] = EMPTY_VALUE;

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
               dpo[i+k] = dpo[i] + (dpo[i+n]-dpo[i])*k/n;
               avg[i+k]  = avg[i]  + (avg[i+n]-avg[i])*k/n;
            }
   }
   for (i=limit;i>=0;i--)
   {
      if (trend[i]== 1) PlotPoint(i,dpoUa,dpoUb,dpo);
      if (trend[i]==-1) PlotPoint(i,dpoDa,dpoDb,dpo);
   }
   
   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar]   ==  1) doAlert(whichBar,DoubleToStr(LevelUp,2)+" broken up");
         if (trend[whichBar]   == -1) doAlert(whichBar,DoubleToStr(LevelDn,2)+" broken down");
         if (trend[whichBar+1] == -1) doAlert(whichBar,DoubleToStr(LevelDn,2)+" broken up");
         if (trend[whichBar+1] ==  1) doAlert(whichBar,DoubleToStr(LevelUp,2)+" broken down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS),"IFT DPO level ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"IFT DPO"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int xchar = StringGetChar(s, length);
         if((xchar > 96 && xchar < 123) || (xchar > 223 && xchar < 256))
                     s = StringSetChar(s, length, xchar - 32);
         else if(xchar > -33 && xchar < 0)
                     s = StringSetChar(s, length, xchar + 224);
   }
   return(s);
}